Subject: bug#59182: closed (Re: bug#59182: Proposed fix)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 17 Nov 2022 09:43:02 +0000

Your bug report

#59182: 28.1; ediff: Merges with ancestor: Fix computation of hunks and proposed merge

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
59182: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=59182
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#59182: Proposed fix
From: Eli Zaretskii <[email-masked]>
To: Olivier Certner <[email-masked]>
Cc: [email-masked]
Date: Thu, 17 Nov 2022 11:41:53 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Olivier Certner <[email-masked]>
> Date: Thu, 10 Nov 2022 19:35:28 +0100
> 
> On top of emacs-28 branch (49a14c4375ce4c2c).
> 
> The fix is "minimal", in the sense that it doesn't try to refactor/modify unrelated code.

Thanks, I've now installed this on the master branch, and I'm closing
the bug.

Subject: 28.1; ediff: Merges with ancestor: Fix computation of hunks and proposed merge
From: Olivier Certner <[email-masked]>
To: [email-masked]
Date: Thu, 10 Nov 2022 19:29:09 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hunks are not computed correctly because the diff3 command is
invoked with arguments in an incorrect order.  The correct order is
the local file first, the base (or "ancestor") second and the other
file third. 

This erroneous behavior has two consequences.  First, the
output of diff3 would change, since it tries to merge chunks according
to maximal matches between the second and first files, and the second
and third files.  Second, ediff, more precisely, `ediff-do-merge',
would consequently try to merge the reverse of the changes from the
base to the other file, leading to a hard to understand merge result in
some cases.

To see the effect on a simple example, consider what
`ediff-merge-with-ancestors` suggests on the three files attached (run
`ediff-merge-with-ancestor' with file A being 'local.txt', file B being
'other.txt' and file C being 'ancestor.txt').

I noticed this problem on a very hairy merge that I can't reproduce here.

Fix to be attached as soon as the bug is created.

-- 
Olivier Certner